/**
 * Definición de la clase Gato
 *
 * @author
 */
public class Gato implements Comparable<Gato> {
    private String nombre;
    private String color;
    private String raza;

    public Gato(String nombre, String color, String raza) {
        this.nombre = nombre;
        this.color = color;
        this.raza = raza;
    }

    public String getNombre() {
        return nombre;
    }

    public String getRaza() {
        return raza;
    }

    public String toString() {
        return "Nombre: " + this.nombre + "\tColor: " + this.color + "\tRaza: " + this.raza;
    }

    @Override
    public int compareTo(Gato g) {

        // Comparar por nombre alfabéticamente de forma descendente, a - z
        //return this.nombre.toLowerCase().compareTo(g.getNombre().toLowerCase());

        // Comparar por raza alfabéticamente de forma descendente, a - z
        // return this.raza.toLowerCase().compareTo(g.getRaza().toLowerCase());

        // Comparar por raza alfabéticamente de forma ascendente, z - a
        return g.getRaza().toLowerCase().compareTo(this.raza.toLowerCase());
    }

    public boolean equals(Gato g) {
        return (this.nombre).equals(g.getNombre());
    }
}